/*
 UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 MIAGE - UFR 27
 Cours ISI5 / INF2 - Developpement d'Interface

 */

package ihmexamples.exceptiondemo;

/**
 * Programme qui démontre l'usage des exceptions
 * @author kirsch
 */
public class ExceptionDemo {
    public int factorial (int n) throws NegativeFactorialException {
        int f = 1;

        if (n < 0)
            throw new NegativeFactorialException (n);

        for (int i=n; i>0; i--) {
            f *= n;
        }
        return f;
    }

    public static void main (String args[]) {
        int fa=0, fb=0;
        ExceptionDemo ed = new ExceptionDemo();

        try {
            fa = ed.factorial(-4);
            fb = ed.factorial(5);   //jamais atteint
        }
        catch (NegativeFactorialException nfe) {
            System.out.println ("Exception! " + nfe.getMessage());
            nfe.printStackTrace(System.out);
        }

        System.out.println ("fa = " + fa + " fb = " + fb);
    }
}

class NegativeFactorialException extends ArithmeticException {

    public NegativeFactorialException(String s) {
        super(s);
    }

    public NegativeFactorialException (int x) {
        super (new String("Factorial of " + x + " impossible"));
    }

    public NegativeFactorialException() {
    }
}

