/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 * Cours ISI5 / INF2 - Developpement d'Interface
 */

package ihmexamples.tempconverter.converterawt;

/**
 * Temperature Converter keeps track of a given temperature in °C or °F
 * and supplies methods for converting from °C to °F and vice-versa
 * @author kirsch
 */

import java.awt.*;
import ihmexamples.tempconverter.*;

public class TempConverterAwtGUI extends java.awt.Frame {

    private java.awt.Button button1;
    private java.awt.CheckboxGroup radiogroup1;
    private java.awt.Checkbox optCelsius;
    private java.awt.Checkbox optFahrenheit;
    private java.awt.Label resultat;
    private java.awt.Panel panel1;
    private java.awt.TextField textField1;


    /** Creates new form TempConverterAwtGUI */
    public TempConverterAwtGUI() {
        initComponents();
    }

    // <editor-fold defaultstate="collapsed" desc="Generated Code">
    private void initComponents() {

        java.awt.GridBagConstraints gridBagConstraints;

        panel1 = new java.awt.Panel();
        panel1.setLayout(new java.awt.BorderLayout());

        textField1 = new java.awt.TextField();
        textField1.setText("");
        textField1.setColumns(10);

        radiogroup1 = new java.awt.CheckboxGroup();
        optCelsius = new java.awt.Checkbox("to Celsius",radiogroup1,true);
        optFahrenheit = new java.awt.Checkbox("to Fahrenheit",radiogroup1,false);
        button1 = new java.awt.Button();
        button1.setLabel("Convert");

        resultat = new java.awt.Label();
        resultat.setText("                 ");



        setLayout(new java.awt.GridBagLayout());

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        add(textField1, gridBagConstraints);

        add(button1, new java.awt.GridBagConstraints());

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 40;
        add(resultat, gridBagConstraints);
        //add(resultat, new java.awt.GridBagConstraints());

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        add(optCelsius, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        add(optFahrenheit, gridBagConstraints);

        //setMinimumSize(new Dimension(300,150));
        setSize(400,150);
        //pack();

         addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        textField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textField1ActionPerformed(evt);
            }
        });

        button1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button1ActionPerformed(evt);
            }
        });
    }

    private void convert (){
        String stringTemp = textField1.getText();
        double result=0;

        try
        {
            double temp = new Double(stringTemp).doubleValue();

            TemperatureConverter tmpc = new TemperatureConverter(temp);

            if (optCelsius.getState()==true)
            {
                result = tmpc.toCelcius();
            }
            else
            {
                result = tmpc.toFahrenheit();
            }
            resultat.setText(Double.toString(result));
        }
        catch (NumberFormatException ex)
        {
            resultat.setText("unknown value");
        }
    }

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {
        System.exit(0);
    }

    private void button1ActionPerformed(java.awt.event.ActionEvent evt) {
        convert();
    }

    private void textField1ActionPerformed(java.awt.event.ActionEvent evt) {
        convert();
    }

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                TempConverterAwtGUI TC = new TempConverterAwtGUI();
                TC.setVisible(true);
            }
        });
    }



}
